=== debian/changelog ===
getdp (2.4.2-1ubuntu1) trusty; urgency=medium

  * Enable mpi on armhf.
  * Enable parallel build.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 23 Dec 2013 18:11:05 +0000

getdp (2.4.2-1build1) trusty; urgency=low

  * Rebuild against latest openmpi

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 22 Dec 2013 15:16:39 +0530

getdp (2.4.2-1) unstable; urgency=low

  * Team upload

  [ Christophe Trophime ]  
  * New upstream release (Closes: #713189)
  * change build system to cmake

  [ Konstantinos Margaritis ]
  * debian/rules: 
    set PETSC_ARCH according to DEB_HOST_ARCH (Closes: #687317)

  [ Sébastien Villemot ]
  * Bump Standards-Version to 3.9.5, no changes needed

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 25 Nov 2013 11:23:20 +0100
