=== debian/watch ===
version=3
opts=uversionmangle=s/-([^-]+)/.$1/,dversionmangle=s/\.dfsg$// \
  http://www.geuz.org/getdp/src/ getdp-([\d.-]+)-source\.tgz
