=== Legacy/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.
@@ -8,7 +8,7 @@
     F_Analytic.cpp F_BiotSavart.cpp F_Coord.cpp F_ExtMath.cpp
       F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
       F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
-      F_Gmsh.cpp F_DiffGeom.cpp
+      F_Gmsh.cpp F_DiffGeom.cpp F_Octave.cpp F_Python.cpp
     BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
       BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
       BF_Facet.cpp BF_Volume.cpp BF_Region.cpp
