=== contrib/Arpack/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2013 P. Dular, C. Geuzaine
+# GetDP - Copyright (C) 1997-2015 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@geuz.org>.
