=== debian/changelog ===
getdp (2.7.0-2) unstable; urgency=medium

  * Don't use -march and -mtune in g++ flags.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 12 Feb 2016 22:48:08 +0000

getdp (2.7.0-1) unstable; urgency=medium

  * Team upload.

  [ Mattia Rizzolo ]
  * Imported Upstream version 2.7.0.
  * Refresh patches and remove disabled ones.
  * Remove useless debian/dirs file.
  * Remove useless README.source file.  This is source format 3.0 (quilt),
    this is not the place to explain how to use quilt.
  * Rename debian/upstream to debian/upstream/metadata.
  * Run wrap-and-sort.
  * Bump debhelper compat level to 9.
  * Install README.txt in all binary packages.
  * debian/rules: semplify it.
  * debian/control:
    + Switch to unversioned Build-Depends on petsc-dev and slepc-dev.
    + Build-Depend on libgsl-dev instead of libgsl0-dev for the GSL2 transition.
    + Move the packaging to git, update Vcs-Git and Vcs-Browser.
    + Bump Standards-Version to 3.9.7, no changes needed.
    + Remove dpkg >= 1.15.4 from getdp Depends, that version is old enough.

  [ Christophe Trophime ]
  * Add python support
  * debian/control:
    + remove lib[scotch]metis, gmsh[-tetgen], libgmsh[-tetgen]-dev,
      libhdf5-mpi-dev from Build-Depends.  Closes: #755973
    + update Build-Depends for the new upstream.

  [Andreas Tille]
  * debian/upstream: add reference.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 12 Feb 2016 19:59:04 +0000
