=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR_PETSC = $(CURDIR)/debian/build/petsc
BUILDDIR_SPARSKIT = $(CURDIR)/debian/build/sparskit

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt


override_dh_auto_build:
	@echo "Building getdp"
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_PETSC)
	@echo "Building getdp-sparskit"
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_SPARSKIT)
	mv $(BUILDDIR_SPARSKIT)/getdp $(BUILDDIR_SPARSKIT)/getdp-sparskit

override_dh_auto_install:
	@echo "Installing getdp"
	dh_auto_install -O--parallel --builddirectory=$(BUILDDIR_PETSC)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR_PETSC) $(BUILDDIR_SPARSKIT)

override_dh_installdocs:
	dh_installdocs --all README.txt

# Grab the version before +dfsg
DEB_SOURCE_PACKAGE = $(shell dpkg-parsechangelog | grep '^Source:' | cut -f 2 -d ' ')
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*,\1,p' | cut -f 1 -d '-')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')
get-orig-source:
	set -ex ; \
        mkdir -p tmp ; \
        uscan --force-download --symlink --check-dirname-level 0 --destdir tmp ; \
        tar -C tmp -xzf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source.tgz ; \
	mv tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)-source tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION); \
        rm -rf tmp/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION)/contrib/Arpack ; \
        GZIP=-9 tar -C tmp -czf \
            $(CURDIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz \
            $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION) ; \
        rm -rf tmp
